
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android之Zygote启动详解 / 憋错料</title>

    <meta name="description" content="Android之Zygote启动详解 我们知道Android系统是基于Linux内核的,在Linux系统中所有的进程都是init进程的子进程.Zygote也一样它是在系统启动的过程中由init进程创建的,在系统启动脚本init.rc中: &lt;span style=&quot;font-size:14px;&quot;&gt;@init.rc service zygote /syste/bin/app_process -Xzygote /system/bin -zygote --start-system-server class  ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Android之Zygote启动详解</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>我们知道Android系统是基于Linux内核的，在Linux系统中所有的进程都是init进程的子进程。Zygote也一样它是在系统启动的过程中由init进程创建的，在系统启动脚本init.rc中：</p>
<pre>&lt;span style=&quot;font-size:14px;&quot;&gt;@init.rc

service zygote /syste/bin/app_process -Xzygote /system/bin -zygote --start-system-server
            class main
            socket zygote stream 666
            onrestart restart surfaceflinger
            ...
&lt;/span&gt;</pre>
<p>关键字server告诉init进程创建一个名为zygote的进程，执行的的程序是/syste/bin/app_process，后面都是传递给这个进程的参数。下面的socket表示这个zygote进行需要一个名称为zygote的socket套接字资源，系统启动后在/dev/socket目录下可以看到相关的文件。</p>
<p>zygote 服务进程也叫孵化进程，在Linux的用户空间进程app_process会做一些zygote进程启动的前期工作，如启动runtime运行时的环境等，接着调用runtime.start()来执行zygote服务。runtime.start()这个函数实际是类函数AndroidRuntime::start()，会创建并启动一个虚拟机实例来执行com.android.internal.os.ZygoteInit这个包的main函数。这个main函数会fork一个子进程来启动systemServer，父进程就作为真正的孵化器存在了，每当系统要求执行一个Android应用程序，Zygote就会接收到socket消息fork出一个子进程来执行该应用程序。&nbsp;而每一个Android应用程序都运行在一个Dalvik虚拟机实例里，每一个虚拟机实例都是一个独立的进程空间。</p>
<p>@frameworks/base/cmds/app_process/app_main.cpp</p>
<pre>&lt;span style=&quot;font-size:14px;&quot;&gt;int main(int argc, char* argv[])
{
	AppRuntime runtime;	// 这里AppRuntime是AndroidRuntime的子类，启动runtime运行时环境。
	...	// 获取参数
	/*
		argv[0] = &quot;-Xzygote&quot;
		argv[1] = &quot;/system/bin&quot;
		argv[2] = &quot;--zygote&quot;
		argv[3] = &quot;--start-system-server&quot;
		startSystemServer = true
	*/
	int i = runtime.addVMArguments(argc. argv);	// 找到参数第一个不是以单个-开始的参数，这里是/system/bin
	runtime.mParentDir = argv[i++]	// 将目录保存到mParentDir变量中

	setArgsv0(argv0, &quot;zygote&quot;)
	set_process_name(&quot;zygote&quot;);

	runtime.start(&quot;com.android.internal.os.zygoteInit&quot;, startSystemServer ? &quot;start-system-server&quot; : &quot;&quot;);
}&lt;/span&gt;</pre>
<p>这里主要就是调用runtime.start() 函数，我们重点看下runtime类型为AppRuntime，它继承于AndroidRuntime类。</p>
<p>@frameworks/base/cmds/app_process/app_main.cpp</p>
<pre>&lt;span style=&quot;font-size:14px;&quot;&gt;class AppRuntime : public AndroidRuntime
{
public:
	AppRuntime() : mParentDir(NULL), mClassName(NULL), mClass(NULL), mArgc(0), mArgv(NULL)
	{}
	...
	const char* getClassName() const {}
	virtual void onVmCreated(JNIEnv* env) {}
	virtual void onStarted() {}
	virtual void onZygoteInit() {}
	virtual void onExit(int code)
	const char* mParentDir;
	const char* mClassName;
	jclass mClas;
	int mArgC;
	const char* const* mArgV;
};&lt;/span&gt;</pre>
<pre>&lt;span style=&quot;font-size:14px;&quot;&gt;@frameworks/base/include/android_runtime/AndroidRuntime.h
@frameworks/base/core/jni/AndroidRuntime.cpp

/* static */ JavaVM* AndroidRuntime::mJavaVM = NULL;
void AndroidRuntime::start(const char* className, const char* options)
{
	...
	JNIEnv *env;

	startVm(&amp;mJavaVM, &amp;env);	// start the virtual machine

	onVmCreated(env);	

	startReg(env);			// Register android functions 

	// call className main
	char *slashClassName = toSlashClassName(className);
	jclass startClass = env-&gt;FindClass(slashClassName);
	jmethodID startMeth = env-&gt;GetStaticMethodID(startClass, &quot;main&quot;, &quot;([Ljava/lang/String;]V)&quot;);
	env-&gt;CallStaticVoidMethod(startClass, startMeth, strArray);
	free(slashClassName);
	...
}&lt;/span&gt;</pre>
<p>这个start()函数主要做三件事：<strong>一是调用startVM()启动虚拟机</strong>；二是<strong>调用startReg()注册JNI方法</strong>；三是<strong>调用com.android.internal.os.ZygoteInit类的main函数</strong>。</p>
<p>1） startVM 启动虚拟机</p>
<p>2） startReg 注册JNI方法</p>
<p>3）启动com.android.internal.os.ZygoteInit的main函数</p>
<p>@frameworks/base/core/java/com/android/internal/os/ZygoteInit.java</p>
<pre>&lt;span style=&quot;font-size:14px;&quot;&gt;public static void main(String argv[]) {
	try {
		SamplingProfilerIntegration.start();

		registerZygoteSocket();		// 注册socket
		preloadClasses();			// 加载资源
		preloadResources();

		SamplingProfilterIntegration.writeZygoteSnapshot();
		gc();
		if(argv[1].equals(&quot;start-system-server&quot;))
			startSystemServer();	// fork一个新的进程system_server
		if(ZYGOTE_FORK_MODE)
			runForkMode();
		else
			runSelectLoopMode();	// Zygote进程进入无限循环，执行孵化工作
		closeServerSocket();
	} catch (MethodAndArgsCaller caller) {
		caller.run();
	}
}&lt;/span&gt;</pre>
<p>这里也是主要做三件事情：一是调用registerZygoteSocket函数创建了一个socket套接字用来和ActivityManagerService通信；二是调用startSystemServer函数启动SystemServer组件；三是调用runSelectLoopMode函数进程一个无限循环在前面创建的套接字socket上等待ActivityManagerService请求创建新的应用程序进程。</p>
<p>1）registerZygoteSocket</p>
<p>fork()创建子进程，父进程返回true。子进程执行RuntimeInit.zygoteInit。</p>
<p>@frameworks/base/core/java/com/android/internal/os/RuntimeInit.java</p>
<pre>&lt;span style=&quot;font-size:14px;&quot;&gt;public class ZygoteInit {
	...
	private static LocalServerSocket sServerSocket;
	private static final String ANDROID_SOCKET_ENV = &quot;ANDROID_SOCKET_zygote&quot;;

	private static void registerZygoteSocket() {
		if(sServerSocket == NULL) {
			int fileDesc;
			String env = System.getenv(ANDROID_SOCKET_ENV);		// 获取环境变量
			fileDesc = Integer.parseInt(env);
			sServerSocket = new LocalServerSocket(createFileDescriptor(fileDesc));
		}
	}
}&lt;/span&gt;</pre>
<p>这里通过System.getenv()获取环境变量ANDROID_SOCKET_ENV的&#20540;，通过这个文件描述符表示/dev/socket/zygote。那么这个环境变量又是谁设置的呢？在前面分析的解释执行系统启动脚本init.rc的init.c文件里面有个service_start()函数就是用来分析zygote并创建和设置相应socket的。</p>
<pre>&lt;span style=&quot;font-size:14px;&quot;&gt;void service_start(struct service *svc, const char* dynamic_args)
{
	...
	pid = fork();
	if ( pid == 0)
	{
		struct socketinfo *si;
		...
		for (si = svc-&gt;sockets; si; si = si-&gt;next) {
			int socket_type = (!strcmp(si-&gt;type, &quot;stream&quot;) ? SOCK_STREAM :
				(!strcmp(si-&gt;type, &quot;dgram&quot;) ? SOCK_DGRAM : SOCK_SEQPACKET));
			int s = create_socket(si-&gt;name, socket_type, si-&gt;perm, si-&gt;uid, si-&gt;gid);
			publish_socket(si-&gt;name, s);
		}
	}
	...
}
#define ANDROID_SOCKET_ENV_PREFIX  &quot;ANDROID_SOCKET_&quot;
#define ANDROID_SOCKET_DIR &quot;/dev/socket&quot;
static void publish_socket(const char *name, int fd)
{
	char key[64] = ANDROID_SOCKET_ENV_PREFIX;
	char val[64];

	strlcpy(key + sizeof(ANDROID_SOCKET_ENV_PREFIX) -1, name, sizeof(key) - sizeof(ANDROID_SOCKET_ENV_PREFIX));
	snprintf(val, sizeof(val), &quot;%d&quot;, fd);
	add_environment(key, val);	// ANDROID_SOCKET_zygote = val
	fcntl(fd, F_SETFD, 0);
}&lt;/span&gt;</pre>
<p>这里每一个service命令都会使init进程调用fork函数创建一个新的进程来分析里面的socket选项，然后调用create_socket()函数在/dev/socket目录下创建一个设备文件，然后获得一个文件描述符并通过publish_socket()写入到环境变量中去。这样就把zygote这个socket的文件描述符写到ANDROID_SOCKET_zygote里面去了，这里创建socket文件描述符的create_socket()函数，最后通过调用execve(svc-&gt;args[0],<br />
 (char**)arg_ptrs, (char**)ENV)去执行zygote的可执行程序，并将环境变量ENV参数传递过去了。所以ZygoteInit.registerZygoteSocket()函数就可以直接从环境变量中取出这个文件描述符来使用。如果其他进程需要打开这个/dev/socket/zygote 文件来和Zygote进程通信就需要通过文件名字连接LocalServerSocket。</p>
<p>2）startSystemServer</p>
<p>@frameworks/base/core/java/com/android/internal/os/ZygoteInit.java</p>
<pre>&lt;span style=&quot;font-size:14px;&quot;&gt;private static boolean startSystemServer() {
	String args[] = {
		&quot;--setuid=1000&quot;,
		&quot;--setgid=1000&quot;,
		&quot;--setgroups=1001,1002,1003,1004,1005,1006...&quot;,
		&quot;--capabilities=13010432,130104352&quot;,
		&quot;--runtime-init&quot;,
		&quot;--nice-name=system_server&quot;,
		&quot;com.android.server.SystemServer&quot;,
	};
	ZygoteConnection.Arguments parsedArgs = null;
	parsedArgs = new ZygoteConnection.Arguments(args);
	ZygoteConnection.applyDebuggerSystemProperty(parsedArgs);
	ZygoteConnection.applyInvokeWithSystemProperty(parsedArgs);
	int pid = Zygote.forkSystemServer(
		parsedArgs.uid, parsedArgs.gid, parsedArgs.gids,
		parsedArgs.debugFlags, null, parsedArgs.permittedCapabilities,
		parsedArgs.effectiveCapabilities));
	if (pid == 0) {	// 子进程
		handleSystemServerProcess(parsedArgs);
	}
	return true;	// 父进程直接返回true
}
&lt;/span&gt;</pre>
<p>这里Zygote进程通过调用Zygote.forkSystemServer()函数创建一个新的进程来启动SystemServer组件。</p>
<pre>&lt;span style=&quot;font-size:14px;&quot;&gt;public class ZygoteInit {
	....
	private static void handleSystemServerProcess(ZygoteConnection.Arguments parsedArgs) {
		closeServerSocket();	// 子进程不需要zygote套接字，直接关闭

		FileUtils.setUMask(FileUtils.S_IRWXG | FileUtils.S_IRWXO);
		...
		RuntimeInit.zygoteInit(parsedArgs.targetSdkVersion, parsedArgs.remainingArgs);
	}
}&lt;/span&gt;</pre>
<pre>&lt;span style=&quot;font-size:14px;&quot;&gt;public class RuntimeInit {
	...

	public static final void zygoteInit(int targetSdkVersion, String[] argv) {
		redirectLogStreams();
		commonInit();
		zygoteInitNative();			// 是一个native函数，主要完成Binder通信机制的初始化
		applicationInit(targetSdkVersion, argv);
	}
	public static final native void zygoteInitNative();

	private static void applicationInit(int targetSdkVersion, String[] argv) {
		VMRuntime.getRuntime().setTargetHeapUtilizatoin(0.75f);
		VMRuntime.getRuntime().setTargetSdkVersion(targetSdkVersion);
		final Arguments args;
		args = new Arguments(argv);
		invokeStaticMain(args.startClass, args.startArgs);
	}
	// 这个 className = &quot;com.android.server.SystemServer&quot;
	private static void invokeStaticMain(String className, String[] argv) {
		Class&lt;?&gt; cl;
		cl = Class.forName(className);
		Method m;
		m = cl.getMethod(&quot;main&quot;, new Class[] {String[].class});
		...
		throw new ZygoteInit.MethodAndArgsCaller(m, argv);
	}
}&lt;/span&gt;</pre>
<p>这个RuntimeInit.ZygoteInit()函数主要执行两个操作：一是调用zygoteInitNative来执行一个Binder进程间通信机制的初始化工作；二是调用com.android.server.SystemServer类的main函数。</p>
<p>(1) zygoteInitNative:</p>
<pre>&lt;span style=&quot;font-size:14px;&quot;&gt;@frameworks/base/core/jni/AndroidRuntime.cpp

static JNINativeMethod gMethods[] = {
     ....
     { &quot;zygoteInitNative&quot;, &quot;()V&quot;, (void*) com_android_internal_os_RuntimeInit_zygoteInit },
     ....
 };

static void com_android_internal_os_RuntimeInit_zygoteInit(JNIEnv* env, jobject clazz)
{
       gCurRuntime-&gt;onZygoteInit();         // 就是启动Binder通信
}

&lt;/span&gt;</pre>
<pre>&lt;span style=&quot;font-size:14px;&quot;&gt;virtual void onZygoteInit()
{
	sp&lt;ProcessState&gt; proc = ProcessState::self();	// 每个进程一份ProcessState对象，打开Binder驱动
	if(proc-&gt;supportsProcess()){
		proc-&gt;startThreadPool();	// 启动一个线程用于Binder通信
	}
}&lt;/span&gt;</pre>
<p>(2)&nbsp;SystemServer.main&nbsp;:</p>
<p>@frameworks/base/services/java/com/android/server/SystemServer.java</p>
<pre>&lt;span style=&quot;font-size:14px;&quot;&gt;public class SystemServer {
	native public static void init1(Strig[] args);

	public static void main(String[] args) {
		....
		VMRuntime.getRuntime().setTargetHeapUtilization(0.8f);
		System.loadLibrary(&quot;android_servers&quot;);
		init1(args);
	}

	public static final void init2() {
		Thread thr = new ServerThread();
		thr.setName(&quot;android.server.ServerThread&quot;);
		thr.start();
	}
}
&lt;span style=&quot;color:#006600;&quot;&gt;@frameworks/base/services/jni/com_android_server_SystemServer.cpp&lt;/span&gt;&lt;/span&gt;</pre>
<pre>&lt;span style=&quot;font-size:14px;&quot;&gt;static void android_server_SystemServer_init1(JNIEnv* env, jobject clazz)
{
	system_init();
}
status_t system_init()
{
	sp&lt;ProcessState&gt; proc(ProcessState::self());
	sp&lt;IServiceManager&gt; sm = defaultServiceManager();
	...
	AndroidRuntime* runtime = AndroidRuntime::getRuntime();
	JNIEnv* env = rungime-&gt;getJNIEnv();
	jclass clazz = env-&gt;FindClass(&quot;com/android/server/SystemServer&quot;);
	jmethodID methodId = env-&gt;GetStaticMethodID(clazz, &quot;init2&quot;, &quot;()V&quot;);
	env-&gt;CallStaticVoidMethod(clazz, methodId);

	ProcessState::self()-&gt;startThreadPool();
	IPCThreadState::self()-&gt;joinThreadPool();
	return NO_ERROR;
}&lt;/span&gt;</pre>
<p>这个SystemServer的main()函数首先会调用JNI方法init1，init1()会调用SystemServer的init2，在init2里面创建一个ServerThread线程执行一些系统关键服务的启动操作。</p>
<pre>&lt;span style=&quot;font-size:14px;&quot;&gt;class ServerThread extends Thread {
	...
	public void run() {
		Looper.prepare();
		// Critical services ...
		ServiceManager.addService(Context.POWER_SERVICE, new PoperManagerService());
		ActivityManagerService.main();
		PackageManagerService.main(context);
		...
	}
}&lt;/span&gt;</pre>
<p>到现在为止，zygote已经fork()子进程完成了SystemServer组件的初始化启动操作，回到zygote.main()里面调用runSelectLoopMode()进入一个循环再前面创建的socket接口上等待ActivityManagerService请求创建新的应用程序。</p>
<p>3）runSelectLoopMode</p>
<pre>&lt;span style=&quot;font-size:14px;&quot;&gt;public class ZygoteInit {
	....
	private static void runSelectLoopMode() throws MethodAndArgsCaller {
		ArrayList&lt;FileDescriptor&gt; fds = new ArrayList();
		ArrayList&lt;ZygoteConnection&gt; peers = new ArrayList();
		FileDescriptor[] fdArray = new FileDescriptor[4];

		fds.add(sServerSocket.getFileDescriptor());
		peers.add(NULL);
		int loopCount = GC_LOOP_COUNT;	// 10
		while(true) {
			fdArray = fds.toArray(fdArray);
			index = selectReadble(fdArray);		// 类似Linux下的select轮询，native 函数
			if(index &lt; 0) {
				...
			} else if(index == 0) {				// 表示有客户端连接上
				ZygoteConnection newPeer = acceptCommandPeer();
				peers.add(newPeer);
				fds.add(newPeer.getFileDescriptor());
			} else {							// 客户端发送了请求过来,交给ZygoteConnection的runOnce()函数完成
				boolean done = peers.get(index).runOnce();
				if(done) {
					peers.remove(index);
					fds.remove(index);
				}
			}
		}
	}

	private static ZygoteConnection acceptCommandPeer() {
		...
		return new ZygoteConnection(sServerSocket.accept());
	}
}&lt;/span&gt;</pre>
<p>这里while(true)循环里面调用selectReadble()，这是一个native函数，类&#20284;select使用多路复用I/O模型。当返回0的时候表示有客户端连接上，ZygoteConnection表示Zygote的一个客户端，每当客户端连接上的时候acceptCommandPeer()返回一个ZygoteConnection对象，ZygoteConnection里面保存着accpet()返回的LocalSocket对象。然后将相应的文件描述符添加到fds里面，下次再对其调用selelct轮询。当返回&#20540;大于0的时候表示有客户端发过来的数据请求，交给ZygoteConnection对象的runOnce()函数处理。</p>
<p>selectReadable()函数对应native函数为：com_android_internal_os_ZygoteInit_SelectReadable()</p>
<pre>static jint com_android_internal_os_ZygoteInit_selectReadable (
        JNIEnv *env, jobject clazz, jobjectArray fds)
{
    if (fds == NULL) {
        jniThrowNullPointerException(env, &quot;fds == null&quot;);
        return -1;
    }

    jsize length = env-&gt;GetArrayLength(fds);
    fd_set fdset;

    if (env-&gt;ExceptionOccurred() != NULL) {
        return -1;
    }

    FD_ZERO(&amp;fdset);

    int nfds = 0;
    for (jsize i = 0; i &lt; length; i++) {
        jobject fdObj = env-&gt;GetObjectArrayElement(fds, i);
        if  (env-&gt;ExceptionOccurred() != NULL) {
            return -1;
        }
        if (fdObj == NULL) {
            continue;
        }
        int fd = jniGetFDFromFileDescriptor(env, fdObj);
        if  (env-&gt;ExceptionOccurred() != NULL) {
            return -1;
        }

        FD_SET(fd, &amp;fdset);

        if (fd &gt;= nfds) {
            nfds = fd + 1;
        }
    }

    int err;
    do {
        err = select (nfds, &amp;fdset, NULL, NULL, NULL);
    } while (err &lt; 0 &amp;&amp; errno == EINTR);

    if (err &lt; 0) {
        jniThrowIOException(env, errno);
        return -1;
    }

    for (jsize i = 0; i &lt; length; i++) {
        jobject fdObj = env-&gt;GetObjectArrayElement(fds, i);
        if  (env-&gt;ExceptionOccurred() != NULL) {
            return -1;
        }
        if (fdObj == NULL) {
            continue;
        }
        int fd = jniGetFDFromFileDescriptor(env, fdObj);
        if  (env-&gt;ExceptionOccurred() != NULL) {
            return -1;
        }
        if (FD_ISSET(fd, &amp;fdset)) {
            return (jint)i;
        }
    }
    return -1;
}</pre>
<p><P>Android之Zygote启动详解</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-29 12:02:16 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e5%90%af%e5%8a%a8/" title="启动">启动</a>, <a href="https://www.biecuoliao.com/tag/service/" title="service">service</a>, <a href="https://www.biecuoliao.com/tag/android/" title="android">android</a>, <a href="https://www.biecuoliao.com/tag/zygote/" title="zygote">zygote</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Android之Zygote启动详解的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38NqOKM.html" rel="bookmark">Android四大组件--Activity详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android四大组件--Activity详解 分类: android android应用android开发 本文的主要内容包括1.activity的建立.配置和使用:2.activity的跳转和传值:3.startActivityForResult:4.activity的生命周期. 1.activity的建立.配置和使用 Activity是一个应用中的组件,它为用户提供一个可视的界面,方便用户操作,比如说拔打电话.照相.发邮件或者是浏览地图等.每个activity会提供一个可视的窗口,一般情况			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPdEDzM.html" rel="bookmark">Android中Intent组件详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Intent是不同组件之间相互通讯的纽带,封装了不同组件之间通讯的条件.Intent本身是定义为一个类别(Class),一个Intent对象表达一个目的(Goal)或期望(Expectation),叙述其所期望的服务或动作.与动作有关的数据等.Android则根据此Intent对象之叙述,负责配对,找出相配的组件,然后将 Intent对象传递给所找到的组件,Android的媒婆任务就完成了. 在Google Doc中是这样描述Intent的(摘自Android中文翻译组)当接收到ContentR			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgPWNn0.html" rel="bookmark">Android开发之InstanceState详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android开发之InstanceState详解 本文介绍Android中关于Activity的两个神秘方法:onSaveInstanceState() 和 onRestoreInstanceState(),并且在介绍这两个方法之后,再分别来实现使用InstanceState保存和恢复数据功能.Android实现屏幕旋转异步下载效果这样两个示例. 首先来介绍onSaveInstanceState() 和 onRestoreInstanceState() .关于这两个方法,一些朋友可能在Andr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wEBDRM.html" rel="bookmark">Android 开发 之 Fragment 详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者 : 韩曙亮 转载请著名出处 : http://blog.csdn.net/shulianghan/article/details/38064191 1. Fragement 概述 Fragement 与 Activity 生命周期关系 : Fragement 嵌入到 Activity 组件中才可以使用, 其生命周期与 Activity 生命周期相关. -- stop 与 destroy 状态 : Activity 暂停 或者 销毁的时候, 其内部嵌入的所有的 Fragement 也会执行			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz1BzA4.html" rel="bookmark">Android开发之WebView详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述: 一个显示网页的视图.这个类是你可以滚动自己的Web浏览器或在你的Activity中简单地显示一些在线内容的基础.它使用了WebKit渲染引擎来显示网页,包括向前和向后导航的方法(通过历史记录),放大和缩小,执行文本搜索等. 需要注意的是:为了让你的应用能够使用WebView访问互联网和加载网页,你必须添加Internet的权限在Android Manifest文件中: &lt;uses-permission android:name=&quot;android.permission.INTERNE			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dNgDZ4.html" rel="bookmark">Android中HttpURLConnection使用详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				认识Http协议 Android中发送http网络请求是很常见的,要有GET请求和POST请求.一个完整的http请求需要经历两个过程:客户端发送请求到服务器,然后服务器将结果返回给客户端,如下图所示: 客户端-&gt;服务器 客户端向服务器发送请求主要包含以下信息:请求的Url地址.请求头以及可选的请求体,打开百度首页,客户端向服务器发送的信息如下所示: 请求URL(Request URL) 上图中的Request URL就是请求的Url地址,即https://www.baidu.com,该Url没			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RwRRv3.html" rel="bookmark">Android目录结构（详解）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android目录结构(详解) 下面是HelloAndroid项目在eclipse中的目录层次结构: 由上图可以看出项目的根目录下共有九个文件(夹),下面就这九个文件(夹)进行详解: 1.1src文件夹和assets文件夹: 每个Android程序都包含资源目录(src)和资产目录(assets),资源和资产听起来感觉没有多大差别,但在存储外部内容时用资源(src)比较多,其中它们的区别在于存放在资源(src)下的内容可以通过应用程序的R类进行访问,而存放在资产(assets)下的内容会保持原始			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41DaWP3.html" rel="bookmark">ANDROID L&mdash;&mdash;Material Design详解（动画篇）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明本文出自大苞米的博客(http://blog.csdn.net/a396901990),谢谢支持! Android L: Google已经确认Android L就是Android Lollipop(5.0). 前几天发现Android5.0正式版的sdk已经可以下载了,而且首次搭载Android L系统的Nexus 6和 Nexus 9也即将上市. 所以是时候开始学习Android L了! 关于Android L如何配置模拟器和创建项目,如果大家有兴趣的话可以看看我之前的一篇文章: A			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDjenk3.html" rel="bookmark">Android开发之异步详解（二）之AsyncTask</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				请尊重他人的劳动成果,转载请注明出处:Android开发之异步详解(二)之AsyncTask http://blog.csdn.net/fengyuzhengfan/article/details/40212745 我曾在&lt;Android开发之异步详解(一)之Thread+Handler&gt;一文中介绍过通过Thread+Handler实现异步操作.感兴趣的朋友可以看一下. 虽然Thread+Handler可以实现更新主线程的UI并实现异步,但Thread+Handler模式需要为每一个任务创建一			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n4AApd4.html" rel="bookmark" class="title">LeetCode：String to Integer &lpar;atoi&rpar;</a>
					<div>
						1.题目名称 String to Integer (atoi) (字符串到数字的转换) 2.题目地址 https://leetcode.com/problems/string-to-integer-a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eApwp0.html" rel="bookmark" class="title">汇编指令速查</a>
					<div>
						指令 功能 AAA 调整加 AAD 调整除 AAM 调整乘 AAS 调整减 ADC 进位加 ADD 加 AND 与 ARPL 调整优先级 BOUND 检查数组 BSF 位右扫描 BSR 位左扫描 BS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49ZyAvM.html" rel="bookmark" class="title">监控摄像头如何进行互联网实时直播</a>
					<div>
						什么是网络监控摄像头 网络摄像头,也就是IP camera, 简称IPcam.是传统摄像头与网络视频技术相结合的新一代产品,除了具备一般传统摄像机所有的图像捕捉功最新款网络摄像头能外,机内还内置了数字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZVjGl3.html" rel="bookmark" class="title">大文件断点下载</a>
					<div>
						(1)实现思路 在下载文件的时候不再是整块的从头开始下载,而是看当前文件已经下载到哪个地方,然后从该地方接着往后面下载.可以通过在请求对象中设置请求头实现. (2)解决方案(设置请求头) //2.创建 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47qog60.html" rel="bookmark" class="title">oracle事务特性详解</a>
					<div>
						原子性 事务是一个完整的操作.事务的各步操作是不可分的(原子的):要么都执行,要么都不执行. -- 创建表 create table account_money ( id number(4) not  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MP8OEmM.html" rel="bookmark" class="title">停止了吸收血液，这颗晶体好像是吃饱了一</a>
					<div>
						”林峰不禁尴尬了,他是来安慰人的,这下可好,安慰没有什么效果,到还有送上了几分打击. “啊!”刘琛再次长舒一口气,这次他没有强忍着,而是任凭酒气上涌,刺激着他的喉咙,胃,还有他的大脑.我也是三十班,近 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBYB5Y4.html" rel="bookmark" class="title">结构体 数组 指针</a>
					<div>
						#include &lt;stdio.h&gt; #include &lt;iostream&gt; #include&lt;math.h&gt; using namespace std; int m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pPLqg4.html" rel="bookmark" class="title">弹出框关闭图标在火狐和谷歌下生效，在IE11下不生效处理</a>
					<div>
						1.问题描述: 如下图弹出框,卸载码为第一个弹出框,检索设备为第二个弹出框,第二个弹出框的关闭图标&quot;X&quot;在火狐和谷歌下生效,点击可以关闭弹出框,而在IE11下点击不生效,无法关闭弹 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wjk2j0.html" rel="bookmark" class="title">Linux tr命令</a>
					<div>
						介绍 tr命令可以对来自标准输入的字符进行替换.压缩和删除.它可以将一组字符变成另一组字符. 语法 tr [OPTION]... SET1 [SET2] 注意:SET2是可选项 OPTION: 不带参 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l71ObM.html" rel="bookmark" class="title">【好程序员笔记分享】C语言之if语句使用注意</a>
					<div>
						ios培训------我的c语言笔记,期待与您交流! #include &lt;stdio.h&gt; int main() { /* if (0) //0:假:1:真 { printf(&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ez2aZ3.html" rel="bookmark" class="title">php实现简单的上一页下一页</a>
					<div>
						思路整理: 现在好多人用id的增1和减1实现上一篇和下一篇但是难道文章ID不会断了吗所以你要知道上个ID和个ID是多少就OK了那怎么解决这个问题呢,很简单例子:假如这篇文章的ID200 &lt;a h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kNmxXM.html" rel="bookmark" class="title">frame-框架</a>
					<div>
						一.框架的形成 1.首先建立所需的网页,html分别是不同的网页,需保存在同一个文件里. 2.建立框架不需要写body标记. 3.cols数值代表了框架的宽度,不同的数值用 &quot;逗号”分开.几 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mmm2EKM.html" rel="bookmark" class="title">一个优化登录判断的技巧</a>
					<div>
						在程序中,我们的http api接口 有些需要登录后 才可以访问, 有些不需要. 所以在接口中会出现: 是否登录的判断. 但是 如果在每个方法里 都加上是否登录的判断 显然有些冗余 此时 我们可以使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rQkOg0.html" rel="bookmark" class="title">flask &plus; apache &plus;wsgi</a>
					<div>
						同事用flask写了一些代码,需要用apache跑起来.下面记录一下搭建的过程 环境:ubuntu 12.04 1.安装相关包: apt-get install python-flask  libap ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmQ8EVM.html" rel="bookmark" class="title">C&plus;&plus;中substr函数的用法</a>
					<div>
						原文地址:http://blog.csdn.net/no_retreats/article/details/7853066 C++中substr函数的用法 #include&lt;string&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWdG1r0.html" rel="bookmark" class="title">VMWARE ESXI 虚拟硬盘的格式&colon;精简置备、厚置备延迟置零、厚置备置零</a>
					<div>
						精简置备(thin): 精简配置就是无论磁盘分配多大,实际占用存储大小是现在使用的大小,即用多少算多少.当客户机有输入输出的时候,VMkernel首先分配需要的空间并进行清零操作,也就是说如果使用精简 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mzn6KlM.html" rel="bookmark" class="title">UVA - 1153 Keep the Customer Satisfied（贪心）</a>
					<div>
						UVA - 1153 Keep the Customer Satisfied Time Limit: 3000MS   Memory Limit: Unknown   64bit IO Format: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLQEmQ0.html" rel="bookmark" class="title">PHP 如何判断当前用户已在别处登录</a>
					<div>
						出处:http://bbs.lampbrother.net/read-htm-tid-121909-ds-1.html#tpc 主要思路:1.登录时,将用户的SessionID记录下来2.验证登录时, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pGwnV3.html" rel="bookmark" class="title">php 基础知识2</a>
					<div>
						php判断方法 'is_类型名称'    php判断方法 $x=&quot;1&quot;; echo gettype(is_string($x)); isset    是否存在 empty   是否 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YWOpX4.html" rel="bookmark" class="title">一款神奇的耳机  值得大学生分期</a>
					<div>
						爱玩游戏.爱听歌的你,相信对耳机的要求是特别特别的高,一款平平凡凡的耳机哪能入耳,追求造型的同时,音质更重要.本人推荐一款潮流造型.超凡音质的耳机. 宁静.专业.轻巧,可以当电脑麦可风用,不只能听歌, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
